# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v2.model_utils import (
    ModelNormal,
    cached_property,
)


def lazy_import():
    from datadog_api_client.v2.model.auth_n_mapping_attributes import AuthNMappingAttributes
    from datadog_api_client.v2.model.auth_n_mapping_included import AuthNMappingIncluded
    from datadog_api_client.v2.model.auth_n_mapping_relationships import AuthNMappingRelationships
    from datadog_api_client.v2.model.auth_n_mappings_type import AuthNMappingsType

    globals()["AuthNMappingAttributes"] = AuthNMappingAttributes
    globals()["AuthNMappingIncluded"] = AuthNMappingIncluded
    globals()["AuthNMappingRelationships"] = AuthNMappingRelationships
    globals()["AuthNMappingsType"] = AuthNMappingsType


class AuthNMapping(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        lazy_import()
        return {
            "attributes": (AuthNMappingAttributes,),
            "id": (str,),
            "included": ([AuthNMappingIncluded],),
            "relationships": (AuthNMappingRelationships,),
            "type": (AuthNMappingsType,),
        }

    attribute_map = {
        "id": "id",
        "type": "type",
        "attributes": "attributes",
        "included": "included",
        "relationships": "relationships",
    }

    read_only_vars = {}

    def __init__(self, id, type, *args, **kwargs):
        """AuthNMapping - a model defined in OpenAPI


        :param id: ID of the AuthN Mapping.
        :type id: str

        :type type: AuthNMappingsType

        :type attributes: AuthNMappingAttributes, optional

        :param included: Included data in the AuthN Mapping response.
        :type included: [AuthNMappingIncluded], optional

        :type relationships: AuthNMappingRelationships, optional
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

        self.id = id
        self.type = type

    @classmethod
    def _from_openapi_data(cls, id, type, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(AuthNMapping, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        self.id = id
        self.type = type
        return self
