# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v2.model_utils import (
    ModelNormal,
    cached_property,
)


def lazy_import():
    from datadog_api_client.v2.model.auth_n_mapping_update_attributes import AuthNMappingUpdateAttributes
    from datadog_api_client.v2.model.auth_n_mapping_update_relationships import AuthNMappingUpdateRelationships
    from datadog_api_client.v2.model.auth_n_mappings_type import AuthNMappingsType

    globals()["AuthNMappingUpdateAttributes"] = AuthNMappingUpdateAttributes
    globals()["AuthNMappingUpdateRelationships"] = AuthNMappingUpdateRelationships
    globals()["AuthNMappingsType"] = AuthNMappingsType


class AuthNMappingUpdateData(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        lazy_import()
        return {
            "attributes": (AuthNMappingUpdateAttributes,),
            "id": (str,),
            "relationships": (AuthNMappingUpdateRelationships,),
            "type": (AuthNMappingsType,),
        }

    attribute_map = {
        "id": "id",
        "type": "type",
        "attributes": "attributes",
        "relationships": "relationships",
    }

    read_only_vars = {}

    def __init__(self, id, type, *args, **kwargs):
        """AuthNMappingUpdateData - a model defined in OpenAPI


        :param id: ID of the AuthN Mapping.
        :type id: str

        :type type: AuthNMappingsType

        :type attributes: AuthNMappingUpdateAttributes, optional

        :type relationships: AuthNMappingUpdateRelationships, optional
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

        self.id = id
        self.type = type

    @classmethod
    def _from_openapi_data(cls, id, type, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(AuthNMappingUpdateData, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        self.id = id
        self.type = type
        return self
